> For the complete documentation index, see [llms.txt](https://docs.cometh.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.cometh.io/integrations/react-hooks/useverifymessage.md).

# useVerifyMessage

## Description

This hook provides functionality to verify a signature for a given message.

## Returns

* **data** (`boolean`): The signature generated.
* **error** (`Error | null`): An error object if the transaction failed, otherwise `null`.
* **isPending** (`boolean`): A boolean indicating whether the transaction is currently pending.
* **isSuccess** (`boolean`): A boolean indicating whether the transaction was successfully sent.
* **isError** (`boolean`): A boolean indicating whether an error occurred during the transaction process.
* **verifyMessage** : A function that verify if the signature corresponds to the given message.&#x20;
* **verifyMessageAsync** : A function that verify if the signature and returns a promise that resolves to the verification result.

## Example

```typescript
import { useVerifyMessage } from "@cometh/connect-react-hooks";
import { useState } from "react";
import type { Hex } from "viem";

function MessageVerifier() {
  const [message, setMessage] = useState("");
  const [signature, setSignature] = useState<Hex>("");
  const { verifyMessageAsync, isPending, isError, error, data } = useVerifyMessage();

  const handleVerify = async () => {
    try {
      const isValid = await verifyMessageAsync({ message, signature });
      console.log("Signature is valid:", isValid);
    } catch (err) {
      console.error("Error verifying message:", err);
    }
  };

  return (
    <div>
      <input
        placeholder="Enter message"
        value={message}
        onChange={(e) => setMessage(e.target.value)}
      />
      <input
        placeholder="Enter signature (hex)"
        value={signature}
        onChange={(e) => setSignature(e.target.value as Hex)}
      />
      <button onClick={handleVerify} disabled={isPending}>
        Verify Signature
      </button>
      {isPending && <p>Verifying signature...</p>}
      {isError && <p>Error: {error as string}</p>}
      {data !== undefined && <p>Signature is {data ? "valid" : "invalid"}</p>}
    </div>
  );
}

export default MessageVerifier;
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.cometh.io/integrations/react-hooks/useverifymessage.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
